const app = getApp()
const util = require("../../../utils/util");
const api = require('../../../api/api.js');
const user = require('../../../utils/user.js');
// const update = require('../../../api/update.js');
import moment from 'moment'



Page({
  data: {
    timer: "",
    dayCalendar: {
      bookTradeNo: '',
      workerNo: '',
      star: 0,
      evalMasterShow: false,
      masterComment: '',
      evalDiscipleShow: false,
      discipleComment: '',
      radioDisciple: '通过',
      askForLeaveDTOS: [],
      workerOrderInfoDTOList: [],
      leaveNum: '',
      finishWorkerOrder: '',
      questionNum: '',
      looseOrder: '',
      looseOrderCount: '',
      cycleOrder: '',
      cycleOrderCount: '',
      rebuyNum: '',
      looseRebuyNum: '',
      cycleRebuyNum: '',

    },
    currentMonth: moment(new Date()).format('YYYY-MM'),
    calcendarFold: true,
    stickShow: false,
    today: util.formetdate(new Date()),
    currentDay: util.formetdate(new Date()),
    isLeaveFold: true,
    orderDisable: true,
    orderDisable1: false,
    activeTab: 1,
    ticketList: [{}, {}],
    monthInfo: {
      finishWorkerOrder: 0,
      orderBonus: 0,
      questionNum: 0,
      looseOrder: 0,
      cycleOrder: 0,
      rebuyBonus: 0,
      looseRebuyNum: 0,
      cycleRebuyNum: 0,
    },
    workerDayInfoList: [],
    weekCalendar: [],
    wholeCalendar: [],


  },
  onPageScroll(e) {
    // console.log(e.scrollTop);
    // if(e.scrollTop > 200){
    //   this.setData({
    //     stickShow: true
    //   });
    // } else {
    //   this.setData({
    //     stickShow: false
    //   });
    // }
  },
  leaveFold() {
    let fold = this.data.isLeaveFold;
    this.setData({
      isLeaveFold: !fold
    });
  },
  copyNum(e) {
    let bookno = e.currentTarget.dataset.bookno;
    console.log(bookno);
    wx.setClipboardData({
      data: bookno,
      success: function (res) {

        wx.showToast({
          title: '复制成功',
          icon: 'none',
          duration: 2000
        });
      }
    })
  },
  callUp(e) {
    let status = e.currentTarget.dataset.status;
    let phone = e.currentTarget.dataset.phone;
    if (status == '待上门' || status == '待履约' || status == '已预约') {
      wx.makePhoneCall({
        phoneNumber: phone
      });
    }

  },
  getQrCode(e) { //加企微 
    let channel = e.currentTarget.dataset.channel;
    let id = e.currentTarget.dataset.id;
    if (channel && channel == '盒马')
      channel = 'hm';
    else channel = 'p';
    wx.navigateTo({
      url: '/pages/upgrade/cp/join?channel=' + channel + '&id=' + id,
    })
  },
  openMap(e) { //打开地图

    let status = e.currentTarget.dataset.status;
    let address = e.currentTarget.dataset.address;
    if (status == '待上门' || status == '待履约' || status == '已预约') {
      let lnglat = e.currentTarget.dataset.lnglat.split(',');
      let lng = '';
      let lat = "";
      if (lnglat.length > 0) {
        lng = Number(lnglat[0]);
        lat = Number(lnglat[1]);
      }
      console.log(lng, lat);
      wx.openLocation({
        latitude: lat,
        longitude: lng,
        //   name: address,
        address: address,
        scale: 28
      });
    }

  },
  goSchedule() {
    wx.navigateTo({
      url: '/pages/upgrade/scheduleCalc/scheduleCalc',
    })
  },
  goDetail(e) {
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/upgrade/ticketDetail/ticketDetail?bookTradeNo=' + id,
    });
  },
  evalMaster(e) {
    let id = e.currentTarget.dataset.id;
    let workerno = e.currentTarget.dataset.workerno;
    this.setData({
      evalMasterShow: true,
      star: 0,
      masterComment: '',
      bookTradeNo: id,
      workerNo: workerno
    });
  },
  onClickMsterOverlay() {
    this.setData({
      evalMasterShow: false,
    });
  },
  onClickDiscipleOverlay() {
    this.setData({
      evalDiscipleShow: false,
    });
  },
  onStarChange(event) {
    this.setData({
      star: event.detail,
    });
  },
  onRadioChange(event) {
    this.setData({
      radioDisciple: event.detail,
    });
  },
  bindMasterComment(e) {
    this.setData({
      masterComment: e.detail.value
    })
  },
  bindDiscipleComment(e) {
    this.setData({
      discipleComment: e.detail.value
    })
  },
  stop: function () {
    //阻止弹框冒泡和捕获的空事件，不要删除！！！
  },
  submitEvalMaster() {
    if (this.data.star == 0) {
      wx.showToast({
        title: '请选择评价星级',
        icon: 'none'
      })
    } else if (this.data.masterComment == '') {
      wx.showToast({
        title: '请输入跟单体会',
        icon: 'none'
      })
    } else {
      util.request(api.discipleFeedback, {
        feedback: this.data.discipleComment,
        level: this.data.star,
        bookTradeNo: this.data.bookTradeNo,
        workerNo: this.data.workerNo
      }, 'GET').then(res => {
        if (res.errno === 0) {
          wx.showToast({
            title: '评价成功',
            icon: 'none'
          })
          this.setData({
            evalMasterShow: false,
          });
          this.getDayCalendar();
        } else {
          wx.showToast({
            title: res.errmsg,
            icon: 'none'
          })
        }
      });


    }
  },
  evalDisciple(e) {
    let id = e.currentTarget.dataset.id;
    let workerno = e.currentTarget.dataset.workerno;
    this.setData({
      evalDiscipleShow: true,
      radioDisciple: '通过',
      discipleComment: '',
      bookTradeNo: id,
      workerNo: workerno
    });
  },
  submitEvalDisciple() {
    if (this.data.radioDisciple == '') {
      wx.showToast({
        title: '请选择是否通过',
        icon: 'none'
      })
    } else if (this.data.discipleComment == '') {
      wx.showToast({
        title: '请输入内容',
        icon: 'none'
      })
    } else {
      util.request(api.masterFeedback, {
        remark: this.data.discipleComment,
        feedback: this.data.radioDisciple,
        bookTradeNo: this.data.bookTradeNo,
        workerNo: this.data.workerNo
      }, 'GET').then(res => {
        if (res.errno === 0) {
          wx.showToast({
            title: '评价成功',
            icon: 'none'
          })
          this.setData({
            evalDiscipleShow: false,
          });
          this.getDayCalendar();

        } else {
          wx.showToast({
            title: res.errmsg,
            icon: 'none'
          })
        }
      });


    }
  },
  goProblemList(e) {
    // this.setData({
    //   navigateType: 1
    // })
    let id = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '/pages/problem/list/list?bookTradeNo=' + id,
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    //   let current=this.data.wholeCalendar.filter(item=>{return item.day==this.data.currentDay});
    //   if(current.length==0){
    //       return false;
    //   }
    //   let week=current[0].weekOfYear;
    //   let weekCalendar=this.data.wholeCalendar.filter(item=>{
    //     return item.weekOfYear==week;
    //   });
    //   this.setData({
    //      workerDayInfoList:weekCalendar,
    //      weekCalendar:weekCalendar
    //   });




    this.getMonthCalender(false, 'first');


    // this.getDayCalendar();
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getDayCalendar();
    let timer = setInterval(() => {
      console.log('定时刷新日历数据', new Date());
      this.getMonthCalender();
      this.getDayCalendar();
    }, 1 * 60 * 1000);
    this.setData({
      timer: timer
    });

  },
  onHide: function () {
    console.log('onHide');
    clearInterval(this.data.timer);
  },
  onUnload: function () {
    console.log('onunload');
    clearInterval(this.data.timer);
  },
  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.getMonthCalender();

    this.getDayCalendar();
  },
  getDayCalendar() {
    wx.showLoading({
      title: '加载中...',
    });
    util.request(api.dayCalender, {
      date: this.data.currentDay,

    }, 'GET').then(res => {
      wx.hideLoading();
      if (res.errno === 0) {
        console.log(res);
        this.setData({
          dayCalendar: res.data
        });
      }
    }).catch(err => {
      wx.hideLoading();
    });
  },
  getMonthCalender(flag, tag) {
    wx.showLoading({
      title: '加载中...',
    });
    util.request(api.monthCalender, {
      month: this.data.currentMonth,

    }, 'GET').then(res => {
      wx.hideLoading();
      if (res.errno === 0) {
        console.log(res);
        this.setData({
          monthInfo: res.data,
          wholeCalendar: res.data.workerDayInfoList
        });
        if (flag) {
          this.setData({
            calcendarFold: false,
            workerDayInfoList: this.data.wholeCalendar,

          });
        }
        let current = this.data.wholeCalendar.filter(item => {
          return item.day == this.data.currentDay
        });
        if (current.length == 0) {
          return false;
        }
        let week = current[0].weekOfYear;
        let weekCalendar = this.data.wholeCalendar.filter(item => {
          return item.weekOfYear == week;
        });
        this.setData({

          weekCalendar: weekCalendar
        });
        if (tag == 'first') {
          this.setData({
            workerDayInfoList: weekCalendar,
          });
        }
        if (this.data.calcendarFold) {
          this.setData({
            workerDayInfoList: weekCalendar,
          });
        } else {
          this.setData({
            workerDayInfoList: this.data.wholeCalendar,
          });
        }
      } else {
        wx.showToast({
          title: res.errmsg,
          duration: 3000,
          icon: 'none'
        });
      }


    }).catch(err => {
      wx.hideLoading();
    });
  },
  switchDay(e) {
    let day = e.currentTarget.dataset.day;
    this.setData({
      currentDay: day
    });
    this.getDayCalendar();
  },
  calcendarCollapse() {
    let calcendarFold = this.data.calcendarFold;
    if (calcendarFold) {
      this.setData({
        workerDayInfoList: this.data.wholeCalendar,
        calcendarFold: !calcendarFold
      });
    } else {
      this.setData({
        workerDayInfoList: this.data.weekCalendar,
        calcendarFold: !calcendarFold
      });
    }

  },
  lastMonth() {
    console.log(this.data);
    let params = util.getYearMonth(this.data.currentMonth, '-');
    this.setData({
      currentMonth: params
    });
    this.getMonthCalender(true);
  },
  nextMonth() {
    let params = util.getYearMonth(this.data.currentMonth, '+');
    console.log(params);
    this.setData({
      currentMonth: params
    });
    this.getMonthCalender(true);
  },
  goIssueTicket() {
    wx.navigateTo({
      url: '/pages/upgrade/issueTicket/issueTicket',
    })
  },
  supplyCode(e) {
    let bookno = e.currentTarget.dataset.bookno;
    if (bookno.startsWith('JZ')) {
      bookno = bookno.substr(2);
    }
    util.request(api.createMakeUpQRCode, {
      serviceId: bookno
    }, 'GET').then(res => {
      if (res.errno === 0) {
        let url = res.data;
        wx.previewImage({
          current: url, // 当前显示图片的http链接
          urls: [url] // 需要预览的图片http链接列表
        })

      } else {
        wx.showToast({
          title: res.errmsg,
          icon: 'none'
        })
      }
    });



	},
	supplyCode(e){
		let bookno = e.currentTarget.dataset.bookno;
    if (bookno.startsWith('JZ')) {
      bookno = bookno.substr(2);
		}
		app.globalData.diffId=0;
		wx.navigateTo({
			url: '/pages/serviceSupply/serviceSupply?bookno='+bookno,
		});
	},
	supplyRecord(e){
		let bookno = e.currentTarget.dataset.bookno;
    if (bookno.startsWith('JZ')) {
      bookno = bookno.substr(2);
    }
		wx.navigateTo({
			url: '/pages/supplyRecord/supplyRecord?bookno='+bookno,
		});
	},
  onReachBottom() {
    // if (this.data.totalPages > this.data.page) {
    //   this.setData({
    //     page: this.data.page + 1
    //   });
    //   this.getGoodsList();
    // } else {
    //   wx.showToast({
    //     title: '没有更多商品了',
    //     icon: 'none',
    //     duration: 2000
    //   });
    //   return false;
    // }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },








  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

})